﻿/// <typ>UniqID</typ>
/// <file>UniqID.cs</file>
/// <create>24.01.2011 16:06:19</crate>
/// <author>Wolfgang Stelzhammer</author>
///
/// <summary>
///
/// </summary>
/// <copyright>Copyright © 2008-2011 Wolfgang Stelzhammer, All rights reserved!</copyright>
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace StorageHelper.StorageAttributes
{
		/// <summary>
		/// A Property-Digits with a UniqIDAttribute is used for an Unique Identifier. An optionally given Prefix would be added in front of the Propery-Digits then.
		/// </summary>
		[AttributeUsage(AttributeTargets.Property, AllowMultiple = true, Inherited = true)]
		public class UniqIDAttribute : Attribute
		{
				private string _Value = string.Empty;

				public string Value
				{
						get;
						private set;
				}

				//public UniqIDAttribute()
				//{
				//  Digits = "";
				//}

				public UniqIDAttribute(string _prefix)
				{
						Value = _prefix;
				}

				public UniqIDAttribute()
						: this(string.Empty)
				{
				}
		}
}