﻿/// <typ>StorageHelperType</typ>
/// <file>StorageHelperType.cs</file>
/// <create>14.09.2011 22:40:43</crate>
/// <author>Wolfgang Stelzhammer</author>
///
/// <summary>
///
/// </summary>
/// <copyright>Copyright © 2008-2011 Wolfgang Stelzhammer, All rights reserved!</copyright>
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.IO;
using System.Linq;
using System.Text;

using StorageHelper.StorageAttributes;
using StorageHelper.StorageLib;

namespace StorageHelper.StorageBase
{
		public partial class StorageHelperType : PropertyNotify, IStorageHelper
		{
				public string ConnectionString
				{
						get
						{
								return TypeInfo.ConnectionString;
						}
				}

				public int IdDigits
				{
						get
						{
								return TypeInfo.IdDigits;
						}
				}

				[Exclude]
				public bool AutoSave
				{
						get
						{
								return TypeInfo.AutoSave;
						}
						set
						{
								TypeInfo.AutoSave = value;
						}
				}

				private StateInfo StateInfo = new StateInfo(TypeInfo);

				public bool isSticky
				{
						get
						{
								return StateInfo.isSticky;
						}
				}

				public bool isNew
				{
						get
						{
								return StateInfo.isNew;
						}
				}

				public int Id
				{
						get
						{
								if (isNew && StateInfo.Id == 0)
										StateInfo.Id = TypeInfo.tempCounter;

								return StateInfo.Id;
						}
						set
						{
								StateInfo.Id = value;
								StateInfo.isNew = false;
								DoPropertyChanged("Id");
						}
				}

				private string IdString
				{
						get
						{
								return StateInfo.Id.ToString(TypeInfo.DigitFormat);
						}
				}

				public string UniqID
				{
						get
						{
								return StateInfo.UniqID;
						}
				}

				public void addCustomEngineParameter(Dictionary<string, object> ParameterDic)
				{
						foreach (var item in ParameterDic)
						{
								TypeInfo.Engine.CustonConfig.Add(item.Key, item.Value);
						}
				}
		}
}