﻿/// <typ>StorageHelper</typ>
/// <file>StorageHelper.getAttributesMethods.cs</file>
/// <create>22.01.2011 16:14:47</crate>
/// <author>Wolfgang Stelzhammer</author>
///
/// <summary>
///
/// </summary>
/// <copyright>Copyright © 2008-2011 Wolfgang Stelzhammer, All rights reserved!</copyright>

#if DEPRICATED
using System;
using System.Collections.Generic;
using System.Linq;
using System.Reflection;
using System.Text;
using StorageHelper.StorageAttributes;
using StorageHelper.StorageEngines;
using StorageHelper.StorageLib;
using StorageHelper.StorageLib.Depricated;

namespace StorageHelper.StorageBase
{
		public partial class StorageHelperType_DEPRICATED
		{
				private int getIdDigitsAttribute(Type t)
				{
						object[] temp = t.GetCustomAttributes(typeof(IdDigitsAttribute), false);

						if (temp.Count<object>() <= 0)
								return 3;
						IdDigitsAttribute first = (IdDigitsAttribute)temp[0];
						return first.Digits;
				}

				private string getConnectionStringAttribute(Type t)
				{
						string ret = string.Empty;

						object[] temp = t.GetCustomAttributes(typeof(ConnectionStringAttribute), false);

						if (temp.Count<object>() > 0)
						{
								ConnectionStringAttribute connection = (ConnectionStringAttribute)temp[0];
								ret = connection.Value;
						}
						if (ret == string.Empty)
								throw new Exception("keine DatenbankVerbindung (ConnectionString) angegeben!");
						else
								return ret;
				}

				private void getSectionNameAttribute(Type t)
				{
						PropertyInfo[] properties = t.GetProperties();
						//PropertyInfo signup = t.GetProperty("SignUpEmail");
						foreach (PropertyInfo prop in properties)
						{
								if (prop.CanWrite)
								{
										object[] temp = prop.GetCustomAttributes(typeof(SectionNameAttribute), false);
										if (temp.Count<object>() > 0)
										{
												SectionNameAttribute one = (SectionNameAttribute)temp[0];

												if (!SectionNames.Contains(one.Value))
														SectionNames.Add(one.Value);

												if (!PropertiesSectionNames.ContainsKey(one.Value))
												{
														PropertiesSectionNames.Add(one.Value, new StorageSection(one.Value, this.UniqID, null));
												}
												PropertiesSectionNames[one.Value]
														.Properties.Add(new StorageSectionProperty(prop.Name, prop.GetValue(this, null)));
										}
								}
						}
				}

				private StorageEngine_DEPRICATED getStorageEngineAttribute(Type t)
				{
						object[] temp = t.GetCustomAttributes(typeof(StorageEngineAttribute), false);
						StorageEngineAttribute engine = null;
						if (temp.Count<object>() > 0)
						{
								engine = (StorageEngineAttribute)temp[0];
						}
						//else engine=
						if (engine == null)
								return new XmlFile_DEPRICATED();
						else
								return engine.Value;
				}

				private string getDefaultSectionName(Type t)
				{
						object[] temp = t.GetCustomAttributes(typeof(SectionNameAttribute), false);
						if (temp.Count<object>() > 0)
						{
								SectionNameAttribute sn = (SectionNameAttribute)temp[0];
								if (!SectionNames.Contains(sn.Value))
										SectionNames.Add(sn.Value);
								return sn.Value;
						}
						else
								return string.Empty;
				}

				private string getUniqIDAttribute(Type t)
				{
						string ret = Id.ToString(DigitFormat);
						PropertyInfo[] properties = t.GetProperties();

						foreach (PropertyInfo prop in properties)
						{
								object[] temp = prop.GetCustomAttributes(typeof(UniqIDAttribute), false);
								if (temp.Count<object>() > 0)
								{
										UniquProperty = prop;
										UniqIDAttribute UniqID = (UniqIDAttribute)temp[0];
										if (UniqID.Value != "")
												ret += UniqID.Value;
										string tString = string.Empty;
										if (prop.GetValue(this, null) != null)
												tString = prop.GetValue(this, null).ToString();
										if (ret != string.Empty)
												ret += "_";
										if (tString != null || tString != string.Empty || tString != "0")
												ret += tString;
								}
						}
						if (ret == string.Empty)
								ret = /*"This_is_not_a_raly_save_UniqID=" + */this.GetHashCode().ToString();
						ret = ret.Replace(" ", "_");
						return ret;
				}

				private void getNoStorageAttribute(Type t)
				{
						PropertyInfo[] properties = t.GetProperties();

						if (!SectionNames.Contains(this.DefaultSectionName))
								SectionNames.Add(this.DefaultSectionName);
						foreach (PropertyInfo prop in properties)
						{
								if (prop.CanWrite)
								{
										object[] temp = prop.GetCustomAttributes(typeof(NoStorageAttribute), false);

										if (temp.Count<object>() == 0)
										{
												if (!PropertiesSectionNames.ContainsKey(this.DefaultSectionName))
												{
														PropertiesSectionNames.Add(this.DefaultSectionName, new StorageSection(this.DefaultSectionName, this.UniqID, null));
												}
												PropertiesSectionNames[this.DefaultSectionName]
														.Properties.Add(new StorageSectionProperty(prop.Name, prop.GetValue(this, null)));
										}
								}
						}
				}
		}
}
#endif