﻿using System;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using StorageHelper.StorageLib;

namespace StorageHelperTest.StorageLib
{
		/// <summary>
		///Dies ist eine Testklasse für "DeserializeExeceptionTest" und soll
		///alle DeserializeExeceptionTest Komponententests enthalten.
		///</summary>
		[TestClass()]
		public class DeserializeExeceptionTest
		{
				private TestContext testContextInstance;

				/// <summary>
				///Ruft den Testkontext auf, der Informationen
				///über und Funktionalität für den aktuellen Testlauf bietet, oder legt diesen fest.
				///</summary>
				public TestContext TestContext
				{
						get
						{
								return testContextInstance;
						}
						set
						{
								testContextInstance = value;
						}
				}

				#region Zusätzliche Testattribute

				//
				//Sie können beim Verfassen Ihrer Tests die folgenden zusätzlichen Attribute verwenden:
				//
				//Mit ClassInitialize führen Sie Code aus, bevor Sie den ersten Test in der Klasse ausführen.
				//[ClassInitialize()]
				//public static void MyClassInitialize(TestContext testContext)
				//{
				//}
				//
				//Mit ClassCleanup führen Sie Code aus, nachdem alle Tests in einer Klasse ausgeführt wurden.
				//[ClassCleanup()]
				//public static void MyClassCleanup()
				//{
				//}
				//
				//Mit TestInitialize können Sie vor jedem einzelnen Test Code ausführen.
				//[TestInitialize()]
				//public void MyTestInitialize()
				//{
				//}
				//
				//Mit TestCleanup können Sie nach jedem einzelnen Test Code ausführen.
				//[TestCleanup()]
				//public void MyTestCleanup()
				//{
				//}
				//

				#endregion Zusätzliche Testattribute

				/// <summary>
				///Ein Test für "DeserializeExeception-Konstruktor"
				///</summary>
				[TestMethod()]
				public void DeserializeExeceptionConstructorTestXmlStringEmty()
				{
						try
						{
								throw new DeserializeExeception(DeserializeExeception.TypeContentFailures.XmlStringEmty);
						}
						catch (DeserializeExeception de)
						{
								Assert.AreEqual(de.Failure, DeserializeExeception.TypeContentFailures.XmlStringEmty, "Keine String.Emty Fehlernachricht");
								Assert.AreEqual(de.Message, "XmlStringEmty-Fehler bei der Deserialisierung.", "Fehler in FehlerNachricht");
						}
						catch (Exception)
						{
								Assert.Fail("Unbehandelte Exception");
						}
				}

				/// <summary>
				///Ein Test für "DeserializeExeception-Konstruktor"
				///</summary>
				[TestMethod()]
				public void DeserializeExeceptionConstructorTestGeneral()
				{
						try
						{
								throw new DeserializeExeception(DeserializeExeception.TypeContentFailures.General);
						}
						catch (DeserializeExeception de)
						{
								Assert.AreEqual(de.Failure, DeserializeExeception.TypeContentFailures.General, "Keine String.Emty Fehlernachricht");
								Assert.AreEqual(de.Message, "General-Fehler bei der Deserialisierung.", "Fehler in FehlerNachricht");
						}
						catch (Exception)
						{
								Assert.Fail("Unbehandelte Exception");
						}
				}

				/// <summary>
				///Ein Test für "DeserializeExeception-Konstruktor"
				///</summary>
				[TestMethod()]
				public void DeserializeExeceptionConstructorTest()
				{
						try
						{
								throw new DeserializeExeception();
						}
						catch (DeserializeExeception de)
						{
								Assert.AreEqual(de.Failure, DeserializeExeception.TypeContentFailures.General, "Keine String.Emty Fehlernachricht");
								Assert.AreEqual(de.Message, "Fehler bei der Deserialisierung.", "Fehler in FehlerNachricht");
						}
						catch (Exception)
						{
								Assert.Fail("Unbehandelte Exception");
						}
				}
		}
}