﻿using System;
using System.ComponentModel;
using System.Threading;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using StorageHelper.StorageLib;
using StorageHelperTest.SampleTypes;

namespace StorageHelperTest.StorageLib
{
		/// <summary>
		///Dies ist eine Testklasse für "PropertyNotifyTest" und soll
		///alle PropertyNotifyTest Komponententests enthalten.
		///</summary>
		[TestClass()]
		public class PropertyNotifyTest
		{
				private TestContext testContextInstance;

				/// <summary>
				///Ruft den Testkontext auf, der Informationen
				///über und Funktionalität für den aktuellen Testlauf bietet, oder legt diesen fest.
				///</summary>
				public TestContext TestContext
				{
						get
						{
								return testContextInstance;
						}
						set
						{
								testContextInstance = value;
						}
				}

				#region Zusätzliche Testattribute

				//
				//Sie können beim Verfassen Ihrer Tests die folgenden zusätzlichen Attribute verwenden:
				//
				//Mit ClassInitialize führen Sie Code aus, bevor Sie den ersten Test in der Klasse ausführen.
				//[ClassInitialize()]
				//public static void MyClassInitialize(TestContext testContext)
				//{
				//  CreatePropertyNotify();
				//}

				//
				//Mit ClassCleanup führen Sie Code aus, nachdem alle Tests in einer Klasse ausgeführt wurden.
				//[ClassCleanup()]
				//public static void MyClassCleanup()
				//{
				//}
				//
				//Mit TestInitialize können Sie vor jedem einzelnen Test Code ausführen.
				[TestInitialize()]
				public void MyTestInitialize()
				{
						CreatePropertyNotify();
				}

				//
				//Mit TestCleanup können Sie nach jedem einzelnen Test Code ausführen.
				//[TestCleanup()]
				//public void MyTestCleanup()
				//{
				//}
				//

				#endregion Zusätzliche Testattribute

				private ParrentPropNotifTestType parrent;
				private PropNotifTestType child;

				internal virtual void CreatePropertyNotify()
				{
						parrent = new ParrentPropNotifTestType();
						child = parrent.child;
				}

				/// <summary>
				///Ein Test für "DoParrentPropertyChanged"
				///</summary>
				[TestMethod()]
				public void DoParrentPropertyChangedTest()
				{
						string _property = "TestProperty";
						string _ParrentProperty = "child";
						string neuerWert = "asdfksadkfjlhas";
						bool EventChildTrigered = false;
						bool EventParrentTrigered = false;

						child.PropertyChanged += (object sender, PropertyChangedEventArgs e) =>
						{
								Assert.AreEqual(e.PropertyName, _property, "Fehlerhaftes Property am Child wurde gemeldet");
								EventChildTrigered = true;
						};
						parrent.PropertyChanged += (object sender, PropertyChangedEventArgs e) =>
						{
								Assert.AreEqual(e.PropertyName, _ParrentProperty, "Fehlerhaftes Property am Parrent wurde gemeldet");
								EventParrentTrigered = true;
						};

						child.TestProperty = neuerWert;

						Assert.IsTrue(EventChildTrigered, "PropertyNotifyEvent wurde am Child nicht gefeuert!");
						Assert.IsTrue(EventParrentTrigered, "PropertyNotifyEvent wurde am Parrent nicht gefeuert!");
				}

				/// <summary>
				///Ein Test für "DoPropertyChanged"
				///</summary>
				[TestMethod()]
				public void DoPropertyChangedTest()
				{
						string _property = "TestProperty";
						string neuerWert = "asdfksadkfjlhas";
						bool EventTrigered = false;

						child.PropertyChanged += (object sender, PropertyChangedEventArgs e) =>
						{
								Assert.AreEqual(e.PropertyName, _property, "Fehlerhaftes Property wurde gemeldet");
								EventTrigered = true;
						};

						child.TestProperty = neuerWert;
						Assert.IsTrue(EventTrigered, "PropertyNotifyEvent wurde nicht gefeuert!");
				}
		}
}