﻿/// <typ>StorageSectinProperty</typ>
/// <file>StorageSectinProperty.cs</file>
/// <create>31.01.2011 12:31:27</crate>
/// <author>Wolfgang Stelzhammer</author>
///
/// <summary>
///
/// </summary>
/// <copyright>Copyright © 2008-2011 Wolfgang Stelzhammer, All rights reserved!</copyright>
#if DEPRICATED
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Xml;
using System.Xml.Schema;
using System.Xml.Serialization;

namespace StorageHelper.StorageLib.Depricated
{
		[Serializable]
		public class StorageSectionProperty
		{
				public string Name
				{
						get;
						set;
				}

				public string StringValue
				{
						get;
						set;
				}

				public bool isInnerSerialized
				{
						get;
						set;
				}

				public string TypeString
				{
						get
						{
								if (PropType == null)
										return null;
								else
										return PropType.AssemblyQualifiedName;
						}
						set
						{
								PropType = Type.GetType(value);
						}
				}

				[XmlIgnore]
				public Type PropType
				{
						get;
						set;
				}

				[XmlIgnore]
				public object Value
				{
						get
						{
								if (!isInnerSerialized)
										return StringValue;
								else
								{
										XmlSerializer serializer = new XmlSerializer(PropType);
										return serializer.Deserialize(new StringReader(StringValue));
								}
						}
						set
						{
								if (value != null)
								{
										PropType = value.GetType();
										if (PropType.Name == "String")
										{
												StringValue = (string)value;
												isInnerSerialized = false;
										}
										else
										{
												isInnerSerialized = true;
												XmlSerializer serializer = new XmlSerializer(PropType);
												StringWriter sw = new StringWriter();
												serializer.Serialize(sw, value);
												Value = sw.ToString();
										}
								}
								else
										StringValue = null;
						}
				}

				public StorageSectionProperty()
				{
				}

				public StorageSectionProperty(string _Name, object _Value)
				{
						Name = _Name;
						Value = _Value;
				}
		}
}
#endif