﻿/// <typ>TypeContent</typ>
/// <file>TypeContent.cs</file>
/// <create>22.09.2011 00:24:02</crate>
/// <author>Wolfgang Stelzhammer</author>
///
/// <summary>
///
/// </summary>
/// <copyright>Copyright © 2008-2011 Wolfgang Stelzhammer, All rights reserved!</copyright>
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Xml.Serialization;

namespace StorageHelper.StorageLib
{
		public class TypeContent : SerializableDictionary<string, string>
		{
				public TypeContent()
				{
				}

				private static XmlSerializer serial = new XmlSerializer(typeof(TypeContent));

				public string toXmlSerialize()
				{
						StringWriter sw = new StringWriter();
						serial.Serialize(sw, this);
						return sw.ToString();
				}

				public static TypeContent fromXmlDeserialize(string XmlString)
				{
						if (XmlString == null || XmlString == string.Empty)
								throw new DeserializeExeception(DeserializeExeception.TypeContentFailures.XmlStringEmty);
						StringReader sr = new StringReader(XmlString);
						return (TypeContent)serial.Deserialize(sr);
				}

				#region IEqualityComparer<TypeContent> Member

				public override bool Equals(object objx)
				{
						TypeContent x = (TypeContent)objx;

						if (x.toXmlSerialize() == this.toXmlSerialize())
								return true;
						else
								return false;
				}

				public override int GetHashCode()
				{
						if (this.ContainsKey("Id") && this["Id"] != null && this["Id"] != string.Empty)
								return Convert.ToInt32(this["Id"]);
						else
								return base.GetHashCode();
				}

				#endregion IEqualityComparer<TypeContent> Member

				public override string ToString()
				{
						return toXmlSerialize();
				}
		}
}