﻿using System;
using System.Collections.Generic;
using System.Diagnostics.Contracts;
using System.Linq;
using System.Text;

namespace StorageHelper.StorageLib
{
		public class TypeConverterException : Exception
		{
				public enum ExceptionTypes
				{
						ContainsType,
						isStdType,
						notContainsType
				}

				private static Dictionary<ExceptionTypes, string> Messages
				{
						get
						{
								Contract.Ensures(Contract.Result<Dictionary<ExceptionTypes, string>>() != null);
								Dictionary<ExceptionTypes, string> ret = new Dictionary<ExceptionTypes, string>();

								ret.Add(ExceptionTypes.ContainsType, "Der TypenConverter für den Typ {0} ist bereits vorhanden. Bitte zuerst disen Löschen.");
								ret.Add(ExceptionTypes.notContainsType, "Der TypenConverter für den Typ {0} konnte nicht gefunden werden.");
								ret.Add(ExceptionTypes.isStdType, "Der Typ {0} hat einen bereits Fix eingebauten Standard-Converter. Dieser kann nciht verändert werden!");
								Contract.Assume(Contract.Result<Dictionary<ExceptionTypes, string>>()[ExceptionTypes.ContainsType] != null);
								Contract.Assume(Contract.Result<Dictionary<ExceptionTypes, string>>()[ExceptionTypes.isStdType] != null);
								Contract.Assume(Contract.Result<Dictionary<ExceptionTypes, string>>()[ExceptionTypes.notContainsType] != null);
								return ret;
						}
				}

				private static string getErrMessage(ExceptionTypes _type, string _typeName)
				{
						//Contract.Requires(_typeName != null);
						//Contract.Ensures(Contract.Result<string>() != null);
						Contract.Assume(Messages[_type] != null);
						return string.Format(Messages[_type], _typeName);
				}

				public string CurrentMessage
				{
						get;
						private set;
				}

				public string TypeName
				{
						get;
						private set;
				}

				public ExceptionTypes ExceptionType
				{
						get;
						private set;
				}

				public TypeConverterException(ExceptionTypes _type, string _typeName, Exception _inner = null)
						: base(getErrMessage(_type, _typeName), _inner)
				{
						Contract.Requires(_typeName != null);
						CurrentMessage = getErrMessage(_type, _typeName);
						TypeName = _typeName;
						ExceptionType = _type;
				}
		}
}