﻿using System;
using System.Collections.Generic;
using System.Diagnostics.Contracts;
using System.IO;
using System.Linq;
using System.Text;
using System.Xml.Serialization;

namespace StorageHelper.StorageLib
{
		public partial class TypeConverter
		{
				private static class From
				{
						public static string Int32(object ToObject)
						{
								Contract.Requires(ToObject != null);
								System.Int32 To = (System.Int32)ToObject;
								return To.ToString();
						}

						public static string String(object ToObject)
						{
								Contract.Requires(ToObject != null);
								return (string)ToObject;
						}

						public static string Int16(object ToObject)
						{
								Contract.Requires(ToObject != null);
								System.Int16 To = (System.Int16)ToObject;
								return To.ToString();
						}

						public static string Int(object ToObject)
						{
								Contract.Requires(ToObject != null);
								int To = (int)ToObject;
								return To.ToString();
						}

						// Note: Kein Nativer .net-Typ also wird vorerst mal ausgelassen!
						//public static string Binary(object ToObject)
						//{
						//  Binary
						//}

						public static string Boolean(object ToObject)
						{
								Contract.Requires(ToObject != null);
								Boolean To = (Boolean)ToObject;
								if (To)
										return "true";
								else
										return "false";
						}

						// Note: Byte wird auch ausgelassen!

						public static string DateTime(object ToObject)
						{
								Contract.Requires(ToObject != null);
								DateTime To = (DateTime)ToObject;

								//global::System.Windows.Forms.MessageBox.Show(To.ToUniversalTime().ToString());
								XmlSerializer serializer = new XmlSerializer(typeof(DateTime));

								StringWriter sw = new StringWriter();
								serializer.Serialize(sw, To.ToUniversalTime());
								return sw.ToString();
						}

						// ToDo: Date-Typ muss erst erstellt werden

						public static string Decimal(object ToObject)
						{
								Contract.Requires(ToObject != null);
								System.Decimal To = (System.Decimal)ToObject;

								return To.ToString();
						}

						public static string Double(object ToObject)
						{
								Contract.Requires(ToObject != null);
								Double To = (Double)ToObject;
								return To.ToString();
						}

						public static string Guid(object ToObject)
						{
								Contract.Requires(ToObject != null);
								Guid To = (Guid)ToObject;
								return To.ToString();
						}

						public static string SByte(object ToObject)
						{
								Contract.Requires(ToObject != null);
								SByte To = (SByte)ToObject;
								return To.ToString();
						}

						public static string Single(object ToObject)
						{
								Contract.Requires(ToObject != null);
								Single To = (Single)ToObject;
								return To.ToString();
						}

						public static string TimeSpan(object ToObject)
						{
								Contract.Requires(ToObject != null);
								TimeSpan To = (TimeSpan)ToObject;

								return To.Ticks.ToString();
						}
				}
		}
}