﻿using System;
using System.Collections.Generic;
using System.Diagnostics.Contracts;
using System.IO;
using System.Linq;
using System.Text;
using System.Xml.Serialization;

namespace StorageHelper.StorageLib
{
		public partial class TypeConverter
		{
				private static class To
				{
						public static Object Int32(string FromString)
						{
								return Convert.ToInt32(FromString);
						}

						public static Object Int16(string FromString)
						{
								return Convert.ToInt16(FromString);
						}

						public static Object Int(string FromString)
						{
								return Convert.ToInt32(FromString);
						}

						public static Object String(string FromString)
						{
								return FromString;
						}

						// Note: Kein Nativer .net-Typ also wird vorerst mal ausgelassen!

						public static Object Boolean(string FromString)
						{
								if (FromString == "true")
										return true;
								else
										return false;
						}

						// Note: Byte wird auch ausgelassen!

						public static Object DateTime(string FromString)
						{
								Contract.Requires(FromString != null);
								Contract.Requires(FromString != string.Empty);
								XmlSerializer serializer = new XmlSerializer(typeof(DateTime));
								StringReader sr = new StringReader(FromString);
								DateTime ret = (DateTime)serializer.Deserialize(sr);
								return ret.ToLocalTime();
						}

						// ToDo: Date-Typ muss erst erstellt werden

						public static Object Decimal(string FromString)
						{
								System.Decimal ret = Convert.ToDecimal(FromString);
								return ret;
						}

						public static Object Double(string FromString)
						{
								Double ret = Convert.ToDouble(FromString);
								return ret;
						}

						public static Object Guid(string FromString)
						{
								Contract.Requires(FromString != null);
								Contract.Requires(FromString != string.Empty);
								Guid ret = new Guid(FromString);
								return ret;
						}

						public static Object SByte(string FromString)
						{
								SByte ret = Convert.ToSByte(FromString);
								return ret;
						}

						public static Object Single(string FromString)
						{
								Single ret = Convert.ToSingle(FromString);
								return ret;
						}

						public static Object TimeSpan(string FromString)
						{
								TimeSpan ret = new TimeSpan(Convert.ToInt64(FromString));
								return ret;
						}
				}
		}
}